﻿Public Class Form1

    Private Sub Form1_Load(ByVal sender As Object, ByVal e As System.EventArgs) Handles Me.Load
        Me.Text = AppTitleAndVersion()
        ComboBox_SoundType.SelectedIndex = 0
        Load_INI()
        LightButton(0)
        UpdateControls()
        Refresh()
        Opacity = 1
        Game_Reset()
        Timer1.Interval = 10
        Timer1.Start()
    End Sub

    Private Sub Form1_FormClosing(ByVal sender As Object, ByVal e As System.Windows.Forms.FormClosingEventArgs) Handles Me.FormClosing
        Save_INI()
    End Sub

    Private Sub Form1_SizeChanged(ByVal sender As Object, ByVal e As System.EventArgs) Handles Me.SizeChanged
        UpdateControls()
    End Sub

    Private Sub Timer1_Tick(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles Timer1.Tick
        ReadInputSlots()
        Game_PlaySteps()
    End Sub

    Private OldValues(3) As Single
    Private value As Single
    Private NumActiveInputs As Int32
    Private Sub ReadInputSlots()
        NumActiveInputs = 0
        For i As Int32 = 0 To nButtons - 1
            value = Slots.ReadSlot_NoNan_0_1000(FirstSlot + i)
            If value >= 500 Then
                NumActiveInputs += 1
                If OldValues(i) < 500 Then
                    Game_ButtonPressed(i + 1)
                End If
            End If
            OldValues(i) = value
        Next
        If NumActiveInputs >= 2 Then
            Game_LabelPressed()
        End If
    End Sub

    ' ==========================================================================
    '   CONTROLS
    ' ==========================================================================
    Private Sub ComboBox_SoundType_SelectedIndexChanged(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles ComboBox_SoundType.SelectedIndexChanged
        SoundType = ComboBox_SoundType.SelectedIndex + 1
    End Sub

    Private Sub CheckBox_ThreeButtons_CheckedChanged(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles CheckBox_ThreeButtons.CheckedChanged
        UpdateControls()
    End Sub

    Private Sub CheckBox_TestMode_CheckedChanged(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles CheckBox_TestMode.CheckedChanged
        UpdateControls()
    End Sub

    Private Sub Label1_Click(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles Label1.Click
        Game_LabelPressed()
    End Sub

    Private Sub Button1_MouseDown(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles Button1.MouseDown
        Game_ButtonPressed(1)
        Label1.Focus()
    End Sub
    Private Sub Button2_MouseDown(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles Button2.MouseDown
        Game_ButtonPressed(2)
        Label1.Focus()
    End Sub
    Private Sub Button3_MouseDown(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles Button3.MouseDown
        Game_ButtonPressed(3)
        Label1.Focus()
    End Sub
    Private Sub Button4_MouseDown(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles Button4.MouseDown
        Game_ButtonPressed(4)
        Label1.Focus()
    End Sub

    Private Sub UpdateControls()
        If CheckBox_ThreeButtons.Checked Then
            Dim w As Int32 = 44
            Dim h As Int32 = 140
            Dim s As Int32 = 4
            Button1.Width = w
            Button2.Width = w
            Button3.Width = w
            Button1.Height = h
            Button2.Height = h
            Button3.Height = h
            Button3.Top = Button1.Top
            Button2.Left = Button1.Right + s
            Button3.Left = Button2.Right + s
            Button4.Visible = False
            CheckBox_ThreeButtons.BackColor = Color.Orange
            nButtons = 3
        Else
            Dim w As Int32 = 67
            Dim h As Int32 = 74
            Dim s As Int32 = 6
            Button1.Width = w
            Button2.Width = w
            Button3.Width = w
            Button1.Height = h
            Button2.Height = h
            Button3.Height = h
            Button2.Top = Button1.Top
            Button3.Top = Button2.Bottom + s
            Button2.Left = Button1.Right + s
            Button3.Left = Button4.Right + s
            Button4.Visible = True
            CheckBox_ThreeButtons.BackColor = Color.FromArgb(255, 255, 220)
            nButtons = 4
        End If
        With CheckBox_TestMode
            If .Checked Then
                .BackColor = Color.Orange
                Label1.Width = Button1.Left - 22
            Else
                .BackColor = Color.FromArgb(255, 255, 220)
                Label1.Width = ClientSize.Width - 20
            End If
            Label1.Height = CheckBox_TestMode.Top - 17
        End With
        Label1.Font = New Font(Label1.Font.Name, Label1.ClientSize.Width / 15.0F)
    End Sub

    ' ==========================================================================
    '   FEEDBACK TO USER
    ' ==========================================================================
    Private OutputSlot As Int32

    Friend Sub LightButton(ByVal n As Int32)
        Button1.BackColor = If(n = 1, Color.FromArgb(100, 255, 150), Color.FromArgb(50, 200, 50))
        Button2.BackColor = If(n = 2, Color.FromArgb(255, 150, 150), Color.FromArgb(200, 50, 50))
        Button3.BackColor = If(n = 3, Color.FromArgb(200, 200, 255), Color.FromArgb(100, 100, 200))
        Button4.BackColor = If(n = 4, Color.FromArgb(255, 255, 150), Color.FromArgb(200, 200, 50))
        Button1.Refresh()
        Button2.Refresh()
        Button3.Refresh()
        Button4.Refresh()
        ' -------------------------------------------------- Output to slots
        If n >= 1 Then
            OutputSlot = FirstSlot + 2 + n
            If nButtons = 4 Then OutputSlot += 1
            Slots.WriteSlot(OutputSlot, 1000)
        Else
            Slots.WriteSlot(OutputSlot, 0)
        End If
    End Sub

    Friend Sub Message(ByVal text As String)
        Label1.Text = text
        Label1.Refresh()
    End Sub

End Class
