﻿Module Module_Game

    Private Enum Game_States As Byte
        RESET
        STARTED
        PLAY_STEPS
        REPEAT_STEPS
        END_OF_GAME
    End Enum
    Private Game_Status As Game_States

    Friend FirstSlot As Int32 = 1
    Friend nButtons As Int32

    Private SoundTime As Int32
    Private SoundPause As Int32

    Private StepArray(0) As Int32
    Private ActualStep As Int32
    Private Score As Int32

    Private Sub Game_AddNewStep()
        ReDim Preserve StepArray(StepArray.Length)
        Randomize()
        StepArray(StepArray.Length - 1) = CInt(Rnd() * (nButtons - 1)) + 1
    End Sub

    Friend Sub Game_Reset()
        Form1.Message("Theremino Simon" + vbCrLf + vbCrLf + _
                "Click here or press two buttons to start game")
        PlayResetSound()
        ReDim StepArray(0)
        Game_Status = Game_States.RESET
    End Sub

    Friend Sub Game_LabelPressed()
        Select Case Game_Status
            Case Game_States.RESET
                Form1.Message("Game started")
                Game_Status = Game_States.STARTED
                Game_AddNewStep()
                ActualStep = 1
                Score = 0
                SoundTime = 200
                SoundPause = 200
                Threading.Thread.Sleep(1000)
                Form1.Message("Simon says...")
                Game_Status = Game_States.PLAY_STEPS
            Case Game_States.END_OF_GAME
                Game_Reset()
        End Select
    End Sub

    Friend Sub Game_ButtonPressed(ByVal button As Int32)
        Select Case Game_Status
            Case Game_States.RESET
                If My.Computer.Keyboard.CtrlKeyDown Then
                    PlaySound(button, 100)
                End If
            Case Game_States.REPEAT_STEPS
                PlaySound(button, 100)
                If ActualStep <= StepArray.Length - 1 Then
                    If button = StepArray(ActualStep) Then
                        IncreaseStepAndScore()
                        If ActualStep > StepArray.Length - 1 Then
                            ActualStep = 1
                            Game_AddNewStep()
                            Game_Status = Game_States.PLAY_STEPS
                            Threading.Thread.Sleep(1000)
                            Form1.Message("Simon says...")
                        End If
                    Else
                        Threading.Thread.Sleep(100)
                        PlayErrorSound()
                        Form1.Message("YOUR SCORE IS " + Score.ToString + vbCrLf + vbCrLf + _
                                      "Click here or press two buttons")
                        Game_Status = Game_States.END_OF_GAME
                    End If
                End If
        End Select
    End Sub

    Private Sub IncreaseStepAndScore()
        Form1.Message("OK " + ActualStep.ToString)
        If ActualStep > Score Then
            Score = ActualStep
            If Score >= 5 Then
                SoundTime = 150
                SoundPause = 150
            End If
            If Score >= 10 Then
                SoundTime = 100
                SoundPause = 100
            End If
        End If
        ActualStep += 1
    End Sub

    Friend Sub Game_PlaySteps()
        If Game_Status = Game_States.PLAY_STEPS Then
            If ActualStep <= StepArray.Length - 1 Then
                PlaySound(StepArray(ActualStep), SoundTime)
                Threading.Thread.Sleep(SoundPause)
                ActualStep += 1
            Else
                Form1.Message("Please repeat")
                Game_Status = Game_States.REPEAT_STEPS
                ActualStep = 1
            End If
        End If
    End Sub

End Module
